package com.tofly.xrtymis.custom.utils;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.codec.binary.Base64;

import java.io.*;

@Slf4j
public class Base64ToImageUtil {

    /**
     * 图片转化成base64字符串
     * @param imgPath
     * @return
     */
    public static String getImageStr(String imgPath) {// 将图片文件转化为字节数组字符串，并对其进行Base64编码处理
        String imgFile = imgPath;// 待处理的图片

        byte[] data = null;
        String encode = null; // 返回Base64编码过的字节数组字符串
        // 对字节数组Base64编码
        try (InputStream in = new FileInputStream(imgFile)){
            // 读取图片字节数组
            data = new byte[in.available()];
            in.read(data);
            encode = Base64.encodeBase64String(data);
        } catch (IOException e) {
            log.error("异常",e);
        }
        return encode;
    }

    /**
     * base64字符串转化成图片
     *
     * @param imgData
     *            图片编码
     * @param imgFilePath
     *            存放到本地路径
     * @return
     * @throws IOException
     */
    public static boolean generateImage(String imgData, String imgFilePath){ // 对字节数组字符串进行Base64解码并生成图片
        if (imgData == null) // 图像数据为空
            return false;
        try (OutputStream out = new FileOutputStream(imgFilePath)){
            // Base64解码
            byte[] b = Base64.decodeBase64(imgData);
            for (int i = 0; i < b.length; ++i) {
                if (b[i] < 0) {// 调整异常数据
                    b[i] += 256;
                }
            }
            out.write(b);
            out.flush();
            return true;
        } catch (FileNotFoundException e) {
            log.error("异常",e);
        } catch (IOException e) {
            log.error("异常",e);
        }
        return false;
    }

    /**
     * base64字符串转化成图片
     *
     * @param imgData
     *            图片编码
     * @return
     */
    public static byte[] generateImage(String imgData){ // 对字节数组字符串进行Base64解码并生成图片
        if (imgData == null) // 图像数据为空
            return null;
        // Base64解码
        byte[] b = Base64.decodeBase64(imgData);
        for (int i = 0; i < b.length; ++i) {
            if (b[i] < 0) {// 调整异常数据
                b[i] += 256;
            }
        }
        return b;

    }

}
